#!/opt/edge/venv/bin/python3.11
# -*- coding: utf-8 -*-
# (k) made-on-the-knee-of /dragon, 2019

import sys
import traceback

import ujson
from datetime import datetime
from time import time
import uuid

from io import BytesIO
from PIL import Image

import psycopg2
import psycopg2.extras
import psycopg2.extensions

import edge.types.image

psycopg2.extensions.register_type(psycopg2.extensions.UNICODE)
psycopg2.extensions.register_type(psycopg2.extensions.UNICODEARRAY)

from edge import eventlog
from pyblobstore import bss, vss

reload(sys)
sys.setdefaultencoding('utf8')

conf = {
    'dbhost': '127.0.0.1',
    'dbport': 5433,
    'dbname': 'autocode',
    'dbuser': 'autocode',
    'dbpassword': 'autocode',
    'maxdepth': 600,
    'ainterval': 5,
    'epsdelta': 0.3,
    'maxlevenstein': 1,
    'dist': 40,
    'z1': 20,
    'z2': 12,
    'rmargin': 1.6,
    'restimate': 1.93,
    'argstore': 1,
    'scenestore': 1
}

"""
    margin      estimate
    1.6         1.43
    1.6         1.93

"""

args = {
   "uuid": "",
   "time": "",
   "type": "transit",
   "origin": {
   },
   "measurements": [
      {
         "uuid": "",
         "waypoints": {
            "best": {
               "images": {
                  "license-plates": [
                    {
                     "info": {
                        "size": [
                           0,
                           0,
                           0
                        ],
                        "trans": {
                           "j": [
                              0,
                              1.0
                           ],
                           "i": [
                              1.0,
                              0
                           ],
                           "o": [
                              0,
                              0
                           ]
                        }
                        
                     },
                     "name": "",
                     "time": ""
                    }
                  ],
                  "thumb": {
                     "info": {
                        "size": [
                           0,
                           0,
                           0
                        ],
                        "trans": {
                           "j": [
                              0,
                              1.0
                           ],
                           "i": [
                              1.0,
                              0
                           ],
                           "o": [
                              0,
                              0
                           ]
                        }
                     },
                     "name": "",
                     "time": ""
                  
                  },
                  "vehicle": {
                     "info": {
                        "size": [
                           0,
                           0,
                           0
                        ],
                        "trans": {
                           "j": [
                              0,
                              1.0
                           ],
                           "i": [
                              1.0,
                              0
                           ],
                           "o": [
                              0,
                              0
                           ]
                        }
                     },
                     "name": "",
                     "time": ""
                  },
                  "scene": {
                     "info": {
                        "size": [
                           0,
                           0,
                           0
                        ],
                        "trans": {
                           "j": [
                              0,
                              1.0
                           ],
                           "i": [
                              1.0,
                              0
                           ],
                           "o": [
                              0,
                              0
                           ]
                        }
                     },
                     "name": "",
                     "time": ""
                  }
                  
                  
               },
               "time": "",
               "location": {
                  "lane": "",
                  "place": ""
               },
               "dir": "",
               "vehicle": {
                  "license-plates": [
                    {
                        "type": {
                            "country": {
                                "numeric": 0
                            }
                        },
                        "text": {
                            "ucode": ""
                        },
                        "weight": 99.9
                    }
                  ],
                  "dir": ""
               }
              
               
            },
            "lost": {
               "time": ""
            },
            "catch": {
               "time": ""
            }
         }
      }
   ]
}

dist = {
   "store": "",
   "list": [
      {
         "altref": "args.json",
         "ref": "",
         "name": ""
      },
      {
         "name": "",
         "altref": "scene.jpeg",
         "ref": ""
      },
      {
         "name": "",
         "altref": "plate.jpeg",
         "ref": ""
      },
      {
         "name": "",
         "altref": "thumb.jpeg",
         "ref": ""
      },
      {
         "name": "",
         "altref": "vehicle.jpeg",
         "ref": ""
      }
   ],
   "selected": {
      "scene": "",
      "args": "",
      "plate": "",
      "thumb": "",
      "vehicle": ""
   }
}

pipes = {}


def _avgspeed(_dbconn,_stime):
    with _dbconn:
        with _dbconn.cursor(cursor_factory=psycopg2.extras.RealDictCursor) as dbc:
            dbc.execute("""
                select extract(epoch from avg(dt)) as tm
                from (
                    select c2.plate, c2.ctime as t1, c1.ctime as t2 , c1.ctime - c2.ctime as dt 
                    from 
                        acs.crossing c1 
                        join acs.crossing c2 
                        on c1.tozone = 0 
                            and c2.fromzone = 0 
                            and c1.ctime < %s
                            and c1.ctime > %s - interval '1s' * %s
                            and c2.ctime < c1.ctime 
                            and c2.ctime > c1.ctime - interval '1s' * %s 
                            and c2.plate = c1.plate 
                     order by t1 desc) q;            
            """, (datetime.utcfromtimestamp(_stime),datetime.utcfromtimestamp(_stime),conf['maxdepth'],conf['ainterval'],))
            rv = dbc.fetchone()
            return (conf['dist']+conf['z1']/2.0+conf['z2']/2.0)/rv['tm'] if rv and 'tm' in rv and rv['tm'] else None


def _catchimage(service, ts, size=0):
    rts = int(time() * 1000000)
    image = edge.types.image.ImRgba()
    eventlog.log_i("CI: (%s) -> %s" % (str(service._image_pool._conf), ts))
    service.export_image_rgba2(image,, [vss.VsImageInfo(ts)]
    (w,  h) = image.wh
    if w < 8:
        return None, None, None, None
    if size > 0:
        (w, h) = (int(x*w/size) if w > h else int(x*h/size) for x in (w, h))
        imj = vss.ImHelpers.mk_resize_jpeg(image, w, h)
    else:
        imj = vss.ImHelpers.mk_jpeg2(image)
    return imj, w, h, len(imj)


def _saveblob(service, channel, ts, data, profile, ext):
    blob = bss.MemBlob(profile, ts, data, file_ext=ext)
    service.save(str(channel), blob)
    return blob.name


def _getpipes(dbconn):
    try:
        p = {}
        with open("/etc/edge/setupstore/admin/actions/pipeline.json","rt") as f:
            a = ujson.load(f)
            _p = {x['uuid']: int(x['id']) for x in a} if a else None
            if _p:
                with dbconn:
                    with dbconn.cursor(cursor_factory=psycopg2.extras.RealDictCursor) as dbc:
                        dbc.execute("select * from collection_event_origin")
                        for r in dbc:
                            if r['id'] in _p:
                                p[r['id']] = {
                                    "pipe": _p[r['id']],
                                    "origin": r['origin'],
                                    "param": r['param']
                                }
        return p                                
    except:
        return None


def _mkevent(bservice, vservice, dbconn, iorigin, ilane, idir, ts):
    o = pipes[iorigin] if iorigin in pipes else None
    if not o:
        raise ValueError("Origin not found")
    p = o['pipe']
    vs = vservice[iorigin] if iorigin in vservice else None
    if not vs:
        raise ValueError("Service not found")
    its = int((time()-1) * 1000000)
    uts = int(ts * 1000000)
    tss = datetime.utcfromtimestamp(ts).isoformat()
    (img, imw, imh, ims) = _catchimage(vs, uts, 960)
    if not img:
        raise RuntimeError("Invalid image")
    iname = _saveblob(bservice, conf['scenestore'], its, img, 'scene', 'jpeg')
    a = {}
    a.update(args)
    guid = str(uuid.uuid1())   
    a['uuid'] = guid
    a['time'] = tss
    a['origin'] = o['origin']
    a['measurements'][0]['uuid'] = str(uuid.uuid1())
    a['measurements'][0]['waypoints']['best']['images']['scene']['info']['size'] = [imw, imh, ims]
    a['measurements'][0]['waypoints']['best']['images']['scene']['name'] = iname
    a['measurements'][0]['waypoints']['best']['images']['scene']['time'] = tss
    a['measurements'][0]['waypoints']['best']['time'] = tss
    a['measurements'][0]['waypoints']['best']['location']['place'] = o['param']['public']['name']
    a['measurements'][0]['waypoints']['best']['location']['lane'] = ilane
    a['measurements'][0]['waypoints']['best']['location']['dir'] = idir
    a['measurements'][0]['waypoints']['best']['vehicle']['dir'] = idir
    a['measurements'][0]['waypoints']['lost']['time'] = tss
    a['measurements'][0]['waypoints']['catch']['time'] = tss
    (im_v, imw, imh, ims) = _imresize(img, 480)
    iname_v = _saveblob(bservice, conf['argstore'], its, im_v, 'vehicle', 'jpeg')
    a['measurements'][0]['waypoints']['best']['images']['vehicle']['info']['size'] = [imw, imh, ims]
    a['measurements'][0]['waypoints']['best']['images']['vehicle']['name'] = iname_v
    a['measurements'][0]['waypoints']['best']['images']['vehicle']['time'] = tss
    (im_p, imw, imh, ims) = _imsplash((130, 30), (128, 128, 128, 0))
    iname_p = _saveblob(bservice, conf['argstore'], its, im_p, 'plate', 'jpeg')
    a['measurements'][0]['waypoints']['best']['images']['license-plates'][0]['info']['size'] = [imw, imh, ims]
    a['measurements'][0]['waypoints']['best']['images']['license-plates'][0]['name'] = iname_p
    a['measurements'][0]['waypoints']['best']['images']['license-plates'][0]['time'] = tss
    (im_t, imw, imh, ims) = _imsplash((224, 224), (128, 128, 128, 0))
    iname_t = _saveblob(bservice, conf['argstore'], its, im_t, 'thumb', 'jpeg')
    a['measurements'][0]['waypoints']['best']['images']['thumb']['info']['size'] = [imw, imh, ims]
    a['measurements'][0]['waypoints']['best']['images']['thumb']['name'] = iname_t
    a['measurements'][0]['waypoints']['best']['images']['thumb']['time'] = tss
    aname = _saveblob(bservice, conf['argstore'], its, ujson.dumps(a), 'args', 'json')
    d = {}
    d.update(dist)
    d['store'] = str(conf['argstore'])
    d['list'][0]['ref'] = aname
    d['list'][0]['name'] = aname
    d['list'][1]['ref'] = iname
    d['list'][1]['name'] = iname
    d['list'][2]['ref'] = iname_p
    d['list'][2]['name'] = iname_p
    d['list'][3]['ref'] = iname_t
    d['list'][3]['name'] = iname_t
    d['list'][4]['ref'] = iname_v
    d['list'][4]['name'] = iname_v
    d['selected']['args'] = aname
    d['selected']['scene'] = iname
    d['selected']['plate'] = iname_p
    d['selected']['thumb'] = iname_t
    d['selected']['vehicle'] = iname_v
    evt = {
        "event": a,
        "dist": d,
        "flag": 0
    }
    with dbconn:
        with dbconn.cursor(cursor_factory=psycopg2.extras.RealDictCursor) as dbc:
            dbc.execute("select * from api_event_add(%s)", (ujson.dumps(evt),))
            rv = dbc.fetchone()
            dbconn.commit()
            if rv:
                if rv['errcode'] == 0:
                    return guid
    return None                


def _imresize(img, size):
    im = Image.open(BytesIO(img))
    im.thumbnail([size, size], Image.ANTIALIAS)
    w, h = im.size
    bff = BytesIO()
    im.save(bff, format="JPEG")
    val = bff.getvalue()
    return val, w, h, len(val)


def _imsplash(size, color):
    im = Image.new('RGBA', size, color)
    bff = BytesIO()
    im.save(bff, format="JPEG")
    w, h = im.size
    val = bff.getvalue()
    return val, w, h, len(val)


def _timestamp(d):
    return (d.replace(tzinfo=None) - datetime.utcfromtimestamp(0)).total_seconds()


if __name__ == '__main__':
    try:
        eventlog.open_log('acs_cross', 'debug')
        eventlog.log_i('startup...')
        
        try:
            dbconn = psycopg2.connect("host=%s port=%d dbname=%s user=%s password=%s" % (
                 conf['dbhost']
                ,conf['dbport']
                ,conf['dbname']
                ,conf['dbuser']
                ,conf['dbpassword']
            ))
            dbconn.autocommit=True
        except:
            eventlog.log_e("CROSS: Error opening database connection!")
            sys.exit(1)
        
        pipes = _getpipes(dbconn)
        if not pipes:
            eventlog.log_e("CROSS: Error getting pipelines!")
            sys.exit(1)
        _bsargs = bss.BsServiceArgs(log_level='debug')
        bservice = bss.init_service(_bsargs)
        _vsargs = {}
        vservice = {}
        for _k,_v in list(pipes.items()):
            _vsargs[_k] = vss.VsServiceArgs(store=_v["pipe"]*10, log_level='debug')
            vservice[_k] = vss.init_service(_vsargs[_k])
        
        ntime = time()

        aspeed = _avgspeed(dbconn,ntime)
        if not aspeed:
            eventlog.log_e('CROSS: Average speed error')
            sys.exit(1)
        atime = (conf['dist'] + conf['z1'] + conf['z2']) * conf['rmargin'] / aspeed;
        atime_left = (conf['dist'] + conf['z2']/2) / aspeed;
        atime_right = (conf['dist'] + conf['z2']/2 + conf['z1']) / aspeed;
        etime = (conf['dist'] + (conf['z1']+conf['z2'])/2)*conf['restimate']/aspeed;
        ztime = (conf['z1']+conf['z2'])/(4*aspeed)

        eventlog.log_i("EST: %s %s %s %s %s -- %s"%(aspeed, atime, atime_left, atime_right, etime, ztime))

        ntime_d = datetime.utcfromtimestamp(ntime)
        ntime_s = ntime_d.isoformat()

        with dbconn:
            with dbconn.cursor(cursor_factory=psycopg2.extras.RealDictCursor) as dbc:
                dbc.execute("""
                    select * 
                    from acs.crossing
                    where
                        flag = 0 and
                        tozone = 0 and
                        ctime < %s - interval '1s' * %s and
                        ctime > %s - interval '1s' * %s
                    order by ctime    
                """,(ntime_d, atime_right*2, ntime_d, conf['maxdepth']))
                rv = dbc.fetchall()
                if not rv:
                    eventlog.log_i("CROSS pass1: nothing to do")
                for r in rv:
                    dbc.execute("""
                        select * 
                        from acs.crossing
                        where 
                            fromzone = 0 and
                            ctime < %s and
                            ctime > %s - interval '1s' * %s and
                            lib.ilevenstein(plate,%s) <= %s
                        order by ctime desc limit 1    
                    """, (r['ctime'], r['ctime'], atime*2, r['plate'], conf['maxlevenstein'],))
                    rrv = dbc.fetchone()
                    flag = 0
                    if rrv:
                        flag |= 1
                        if r['fromzone'] != rrv['tozone']: flag |= 2
                        if r['plate'] != rrv['plate']: flag |= 4
                        dbc.execute("""
                            update acs.crossing 
                            set prev = %s, flag = %s
                            where guid = %s;
                            update acs.crossing 
                            set next = %s, flag = %s
                            where guid = %s;
                        """,(rrv['guid'],flag,r['guid'],r['guid'],flag,rrv['guid'],))
                        eventlog.log_i("par: %s %s %s - %s %s %s" % (r['ctime'],r['plate'],r['fromzone'],rrv['ctime'],rrv['plate'],rrv['tozone']))
            dbconn.commit()
            with dbconn.cursor(cursor_factory=psycopg2.extras.RealDictCursor) as dbc:
                dbc.execute("""
                    select * 
                    from acs.crossing
                    where
                        flag = 0 and
                        tozone = 0 and
                        ctime < %s - interval '1s' * %s and
                        ctime > %s - interval '1s' * %s
                    order by ctime    
                """,(ntime_d, atime_right*2, ntime_d, conf['maxdepth']))
                rv = dbc.fetchall()
                if not rv:
                    eventlog.log_i("CROSS pass2: nothing to do")
                for r in rv:
                    dbc.execute("""
                        select * from (
                            select *,
                                abs(extract(epoch from (ctime - (%s - interval '1s' * %s)))) as dt
                            from acs.crossing
                            where 
                                flag = 0 and
                                fromzone = 0 and
                                tozone = %s and
                                ctime between 
                                    %s - interval '1s' * %s and 
                                    %s - interval '1s' * %s
                        ) q
                        where dt < %s
                        order by dt limit 1
                    """, (r['ctime'], etime, r['fromzone'], r['ctime'], atime, r['ctime'], atime_left, ztime,))
                    rr = dbc.fetchone()
                    flag = 0
                    if rr:
                        flag = 17
                        dbc.execute("""
                            update acs.crossing 
                            set prev = %s, flag = %s
                            where guid = %s;
                            update acs.crossing 
                            set next = %s, flag = %s
                            where guid = %s;
                        """, (rr['guid'], flag, r['guid'], r['guid'], flag, rr['guid'],))
                        eventlog.log_i("num: %s %s %s - %s %s %s" % (r['ctime'], r['plate'], r['fromzone'], rr['ctime'], rr['plate'], rr['tozone']))
                    else:
                        dbc.execute("""
                            select * from acs.ports where tozone = %s limit 1
                        """, (r['fromzone'],))
                        rp = dbc.fetchone()
                        if rp:
                            nts = _timestamp(r['ctime']) - etime
                            nid = None
                            try:
                                nid = _mkevent(bservice, vservice, dbconn, rp['origin'], rp['lane'], rp['direction'], nts)
                            except Exception as e:
                                eventlog.log_e("CROSS MKEVENT: %s with %s" % (str(e), traceback.format_exc()))
                                pass
                            if nid:
                                flag = 33
                                dbc.execute("""
                                    update acs.crossing 
                                    set prev = %s, flag = %s
                                    where guid = %s;
                                    update acs.crossing 
                                    set next = %s, flag = %s
                                    where guid = %s;
                                """, (nid, flag, r['guid'], r['guid'], flag | 128, nid,))
                                eventlog.log_i("!rr: %s %s %s" % (r['ctime'], r['plate'], r['fromzone']))
            dbconn.commit()
            with dbconn.cursor(cursor_factory=psycopg2.extras.RealDictCursor) as dbc:
                dbc.execute("""
                    select * 
                    from acs.crossing
                    where
                        flag = 0 and
                        fromzone = 0 and
                        ctime < %s - interval '1s' * %s and
                        ctime > %s - interval '1s' * %s
                    order by ctime    
                """,(ntime_d, atime_right*2, ntime_d, conf['maxdepth']))
                rv = dbc.fetchall()
                if not rv:
                    eventlog.log_i("COSS pass3: nothing to do")
                for r in rv:
                    dbc.execute("""
                        select * from acs.ports where fromzone = %s limit 1
                    """, (r['tozone'],))
                    rp = dbc.fetchone()
                    if rp:
                        nts = _timestamp(r['ctime']) + etime
                        if nts > ntime:
                            nts = ntime
                        nid = None
                        try:
                            nid = _mkevent(bservice, vservice, dbconn, rp['origin'], rp['lane'], rp['direction'], nts)
                        except Exception as e:
                            eventlog.log_e("CROSS MKEVENT: %s with %s" % (str(e), traceback.format_exc()))
                            pass
                        if nid:
                            flag = 65
                            dbc.execute("""
                                update acs.crossing 
                                set next = %s, flag = %s
                                where guid = %s;
                                update acs.crossing 
                                set prev = %s, flag = %s
                                where guid = %s;
                            """, (nid, flag, r['guid'], r['guid'], flag | 128, nid,))
                            eventlog.log_i("!fr: %s %s %s" % (r['ctime'], r['plate'], r['fromzone']))
    except SystemExit:
        pass
    except Exception as e:
        eventlog.log_e("CROSS ERROR: %s with %s" % (str(e), traceback.format_exc()))
    finally:
        bss.fini_service(bservice)
        for _k, _v in list(vservice.items()):
            vss.fini_service(_v)
        eventlog.log_i('finish...')
        eventlog.close_log()


